###############################################################################
# MessageIndex.pl                                                             #
###############################################################################
# YaBB: Yet another Bulletin Board                                            #
# Open-Source Community Software for Webmasters                               #
# Version:        YaBB 1 Gold - SP 1.3                                        #
# Released:       December 2001; Updated April 6, 2003                        #
# Distributed by: http://www.yabbforum.com                                    #
# =========================================================================== #
# Copyright (c) 2000-2003 YaBB (www.yabbforum.com) - All Rights Reserved.     #
# Software by: The YaBB Development Team                                      #
#              with assistance from the YaBB community.                       #
# Sponsored by: Xnull Internet Media, Inc. - http://www.ximinc.com            #
###############################################################################

$messageindexplver = "1 Gold - SP 1.3";

sub MessageIndex {
	my $start = int( $INFO{'start'} ) || 0;
	my( $bdescrip, $counter, $buffer, $pages, $showmods, $mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate, $dlp, $threadlength, $threaddate );
	my( @boardinfo, @threads );
	my( $threadcount, $messagecount, $lastposttime, $lastposter ) = &BoardCountGet($currentboard);
	my $maxindex = $INFO{'view'} eq 'all' ? $threadcount : $maxdisplay;
	my($filetype_info, $filesize_info, $extensions);
	$extensions = join(" ", @ext);
	$filetype_info = $checkext == 1 ? qq~$fatxt{'2'} $extensions~ : qq~$fatxt{'2'} $fatxt{'4'}~;
	$filesize_info = $limit != 0 ? qq~$fatxt{'3'} $limit KB~ : qq~$fatxt{'3'} $fatxt{'5'}~;

	# Make sure the starting place makes sense.
	if( $start > $threadcount ) { $start = int( $threadcount % $maxindex ) * $maxindex; }
	elsif( $start < 0 ) { $start = 0; }

	# There are three kinds of lies: lies, damned lies, and statistics. 
	# - Mark Twain
	
	my($pageindex);
	$start = ( int( $start / $maxindex ) ) * $maxindex;
	$pagenumb = int(($threadcount - 1) / $maxindex) + 1;
	$lastptn = ($pagenumb - 1) * $maxindex;
	if($pagenumb < 2) { $pageindex = 1 }
	else {
		$pageindex .= qq~	$pagenumb &nbsp;
		<script language="JavaScript1.2" type="text/javascript">
		function SelPage(pstart) {
			location.href="$cgi;action=messageindex;start="+pstart;
		}
		</script>
		~;
		$startpage = 0;
		if($start < $maxindex) { $pageindex .= qq~<img src="$imagesdir/none.gif" border="0" alt="" align="absmiddle">~; }
		else {
			$prevpage = $start - $maxindex;
			$pageindex .= qq~<a href="$cgi;action=messageindex;start=$prevpage"><img src="$imagesdir/prev.gif" border="0" alt="" align="absmiddle"></a>~;
		}
		$pageindex .= qq~<form style="display: inline" method="POST" name="pageselect">
		<select name="pageindex" class="catbg" style="width: 50px; font-size: 12px; margin-left: 0px; margin-right: 0px; margin-top: 0px; margin-bottom: 0px" onChange="if(this.options[this.selectedIndex].value) SelPage(this.options[this.selectedIndex].value)">~;
		for($i=1; $i<=$pagenumb; $i++) {
			$selected = "";
			if($start == $startpage) { $selected = "selected" }
			$pageindex .= qq~<option value="$startpage" $selected>$i</option>~;
			$startpage += $maxindex;
		}
		$pageindex .= qq~</select></form>~;
		if($start >= $lastptn) { $pageindex .= qq~<img src="$imagesdir/none.gif" border="0" alt="" align="absmiddle">~; }
		else {
			$nextpage = $start + $maxindex;
			$pageindex .= qq~<a href="$cgi;action=messageindex;start=$nextpage"><img src="$imagesdir/next.gif" border="0" alt="" align="absmiddle"></a>~;
		}
	}


	# Determine what category we are in.
	fopen(FILE, "$boardsdir/$currentboard.ctb") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.ctb");
	$cat = <FILE>;
	fclose(FILE);
	fopen(FILE, "$boardsdir/$cat.cat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $cat.cat");
	$currcat = $cat;
	$cat = <FILE>;
	fclose(FILE);

	# Get the board's description
	fopen(FILE, "$boardsdir/$currentboard.dat") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.dat");
	@boardinfo = <FILE>;
	fclose(FILE);
	chomp @boardinfo;
	$bdescrip = $boardinfo[1];

	# Open and quickly read the current board thread list.
	# Skip past threads until we reach the "page" we want.
	fopen(FILE, "$boardsdir/$currentboard.txt") || &fatal_error("300 $txt{'106'}: $txt{'23'} $currentboard.txt");
	@threadlist = <FILE>;
	$threadcount = $#threadlist;
	@threadlist2 = '';
	fclose(FILE);

	# Sticky Threads
	fopen(FILE, "$boardsdir/sticky.stk") || &fatal_error("300 $txt{'106'}: $txt{'23'} sticky.stk");
	@stickys = <FILE>;
	$stickycount = $#stickys;
	fclose(FILE);
	for ($i=0; $i<=$threadcount; $i++) {
		($mnum) = split( /\|/, $threadlist[$i] );
		$l = 0;
		$is = 0;
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				$is = 1;
				$stickylist{$l} = $threadlist[$i];
				#splice(@threadlist,$i,1);
				last;
			}
			$l++;
		}
		if ($is == 0) { push(@threadlist2,$threadlist[$i]); }
	}
	if (!($threadlist2[0])) { shift(@threadlist2); }

	#now sort the stickys
	@stickylist2 = sort {$b <=> $a } keys %stickylist;
	###Next 2 lines Sticky Group mod
	$stkynum = '';
	if($start < $maxdisplay){ $stkynum = scalar @stickylist2; }
	for ($i=0; $i<=$stickycount; $i++) {
		chomp $stickylist{$i};
		if ($stickylist{$i}) { unshift(@threadlist2,"$stickylist{$i}\n"); }
	}

	$counter = 0;
	$tmpa = '';
	if($counter < $start && ($buffer = $threadlist2[$counter])) {
		$tmpa = $buffer;
		$counter++;
	}
	while($counter < $start && ($buffer = $threadlist2[$counter])) { $counter++; }

	$#threads = $maxindex - 1;
	$curln = $counter;
	$counter = 0;
	while( $counter < $maxindex && ( $buffer = $threadlist2[$curln+$counter] ) ) {
		chomp $buffer;
		$threads[$counter] = $buffer;
		$counter++;
	}
	$#threads = $counter - 1;

	# Let's get the info for the first thread in this forum.
	$tmpa ||= $threads[0];
	($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $tmpa );

	# Mark current board as seen.
	&dumplog($currentboard);

	# Build a list of the board's moderators.
	if( scalar keys %moderators > 0 ) {
		if( scalar keys %moderators == 1 ) { $showmods = qq~($txt{'298'}: ~; }
		else { $showmods = qq~($txt{'299'}: ~; }
		while( $_ = each(%moderators) ) {
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}" class="nav">$moderators{$_}</a>, ~;
		}
		$showmods =~ s/, \Z/)/;
	}

	# Load censor list.
	fopen(FILE,"$vardir/censor.txt");
	while( chomp( $buffer = <FILE> ) ) {
		($tmpa,$tmpb) = split(/=/,$buffer);
		push(@censored,[$tmpa,$tmpb]);
	}
	fclose(FILE);
# Begin addon for boardlinksSP1
	$blink = '';
	$i=0;
	$ii=0;
	while($LinkBoard[$i]) {
		if ($LinkBoard[$i] eq $currentboard){
			if ($ii == 0){
				if ( $LinkURL[$i] =~ m/\/ ) {
					$blink .= qq~<a href="mailto:$LinkURL[$i]">$LinkName[$i]</a>~;
				} else {
					$blink .= qq~<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
				}
				$ii=1;
			} else {
				if ( $LinkURL[$i] =~ m/\/ ) {
					$blink .= qq~$blinkstxt{'13'}<a href="mailto:$LinkURL[$i]">$LinkName[$i]</a>~;
				} else {
					$blink .= qq~$blinkstxt{'13'}<a href="$LinkURL[$i]" target=_blank>$LinkName[$i]</a>~;
				}
			}
		}
		$i++;
	}
	if ($blink ne ''){
		$blink = qq~<table width="100%" cellpadding=3 cellspacing=0><TD align="center" class="catbg" bgcolor="$color{'titletext'}"><font size=2>$blinkstxt{'12'}$boardname</font><BR>$blink</TD></table><BR><BR>~;
	}
	if ($boardlinks != 1) {	$blink =~ s~\~\@~ig; $yymain .= "$blink"; }
# End addon for boardlinksSP1

	# Print the header and board info.
	$curboardurl = $curposlinks ? qq~<a href="$cgi" class="nav">$boardname</a>~ : $boardname;
	if((exists $moderators{$username} && $modview == 1) || ($settings[7] eq 'Administrator' && $adminview == 1) || ($settings[7] eq 'Global Moderator' && $gmodview == 1)) {
		$yymain .= qq~<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>~;
	}
	$yymain .= qq~
<table width="100%" cellpadding="0" cellspacing="0">
  <tr>
    <td><font size="1" class="nav"><b>
    <IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    <a href="$scripturl" class="nav">$mbname</a><br>
    <IMG SRC="$imagesdir/tline.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    <a href="$scripturl#$currcat" class="nav">$cat</a><br>
    <IMG SRC="$imagesdir/tline2.gif" BORDER=0><IMG SRC="$imagesdir/open.gif" BORDER=0>&nbsp;&nbsp;
    $curboardurl</b> <font size="1">$showmods</font></font></td>
  </tr>
</table>
~;
if (($settings[7] eq 'Administrator' && $adminview >= 2) || ($settings[7] eq 'Global Moderator' && $gmodview >= 2) || (exists $moderators{$username} && $modview >= 2)){
	$yymain .= qq~<form name="multiadmin" action="$scripturl?board=$currentboard;action=multiadmin" method="POST" style="display: inline">~;
}
if($ShowBDescrip && $bdescrip ne "") {
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td width="100%"><font size="1" color="#ffffff">$bdescrip</font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
~;
}
$yymain .= qq~
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size="1" color="#ffffff"><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size=-1>
~;
	if ($username ne 'Guest') {
if($showmarkread) {
	$yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~;
}
}
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>$menusep<a href="$cgi;action=post;title=$polltxt{'1a'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
          </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
~;
if($autoapplyrate{$currentboard} == 1 && $viewrateindex{$currentboard} == 1) {
	$yymain .= qq~
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size="1">&nbsp;</font></td>
	~;
	if($rategraph{$currentboard} == 1) {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="32%"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>~;
	}
	else {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="25%"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>~;
	}
	$yymain .= qq~
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="12%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="19%"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
	~;
	if($rategraph{$currentboard} == 1) {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="16%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$mbcrate{'04'}</b></font></td>~;
	}
	else {
		$yymain .= qq~<td class="titlebg" bgcolor="$color{'titlebg'}" width="23%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$mbcrate{'04'}</b></font></td>~;
	}
	$yymain .= qq~
      </tr>
	~;
}
else {
	$yymain .= qq~
      <tr>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="10%" colspan="2"><font size="1">&nbsp;</font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="44%"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'70'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="14%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'109'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'110'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="4%" align="center"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'301'}</b></font></td>
        <td class="titlebg" bgcolor="$color{'titlebg'}" width="24%"><font size="1" class="text1" color="$color{'titletext'}"><b>$txt{'111'}</b></font></td>
~; 
if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)){ 
      $yymain .= qq~ 
       <td class="titlebg" bgcolor="$color{'titlebg'}" width="20%" align="center" nowrap> <img src="$imagesdir/locked.gif" alt="$txt{'104'}" border="0">   
<img src="$imagesdir/sticky.gif" alt="$txt{'781'}" border="0">   
<img src="$imagesdir/admin_move.gif" alt="$txt{'132'}" border="0">  
<img src="$imagesdir/admin_rem.gif" alt="$txt{'63'}" border="0"></td>  
      ~; 
} 
elsif (($settings[7] eq 'Administrator' && $adminview != 0) || ($settings[7] eq 'Global Moderator' && $gmodview != 0) || (exists $moderators{$username} && $modview != 0)){ 
      $yymain .= qq~ 
       <td class="titlebg" bgcolor="$color{'titlebg'}" width="20%" align="center"><font size=2 class="text1" color="$color{'titletext'}"><b>$txt{'2'}</b></font></td> 
      ~; 
} 
$yymain .= qq~ 
      </tr>
	~;
}
	$yymain .= qq~
~;

###Start Sticky Group mod
if($stkynum){
	$yymain .= qq~
      <tr>
        <td colspan="8" align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%"><font size="1"><b>&nbsp;$stickygrp{'1'}</b></font></td>
      </tr>
~;
}
###End Sticky Group mod

	# Begin printing the message index for current board.
	$counter = $start;
	foreach( @threads ) {
		($mnum, $msub, $mname, $memail, $mdate, $mreplies, $musername, $micon, $mstate) = split( /\|/, $_ );
		# Set thread class depending on locked status and number of replies.
		$threadclass = 'thread';
		if( $mstate == 1 ) { $threadclass = 'locked'; }
		elsif( $mreplies > 24 ) { $threadclass = 'veryhotthread'; }
		elsif( $mreplies > 14 ) { $threadclass = 'hotthread'; }
		elsif( $mstate == 0 ) { $threadclass = 'thread'; }
		foreach $curnum (@stickys) {
			if ($mnum == $curnum) {
				if($threadclass eq 'locked') { $threadclass = 'stickylock'; }
				else { $threadclass = 'sticky'; }
			}
		}
		my $stickdir;
		if (exists $moderators{$username} || $settings[7] eq 'Administrator' || $settings[7] eq 'Global Moderator') {
		if ($threadclass eq "sticky"){$stickdir = qq~<a href="$cgi;action=rearrsticky;num=$mnum;direction=up"><font size="2">&nbsp;&nbsp;<b>&uarr;</b></font></a><a href="$cgi;action=rearrsticky;num=$mnum;direction=down"><font size="2"><b>&darr;</b></font> </a>~;}}

		# Decide if thread should have the "NEW" indicator next to it.
		# Do this by reading the user's log for last read time on thread,
		# and compare to the last post time on the thread.
		## LAST READ MOD ##
		$stuff = &getlog($mnum);
		($dlp, $lastread) = split( /\|/, $stuff );
		if ($lastread ne '') { $lastread = qq~;start=$lastread#$lastread~;}
		## /LAST READ MOD ##
		$threaddate = stringtotime($mdate);
		if( $max_log_days_old && $dlp < $threaddate && $username ne 'Guest' && &getlog("$currentboard--mark") < $threaddate ) {
			## LAST READ MOD ##
			$new = qq~<a href="$cgi;action=display;num=$mnum$lastread"><img src="$imagesdir/new.gif" border="0" alt="$txt{'302a'}"></a>~; 
			## /LAST READ MOD ##
		}
		else { $new = ''; }

		# Load the current nickname of the account name of the thread starter.
		$micon = qq~<img src="$imagesdir/$micon.gif" alt="" border="0" align="middle">~;
		$mpoll = "";
		if (-e "$datadir/$mnum.poll") {
			$mpoll = qq~<b>$polltxt{'15'}: </b>~;
			fopen (FILE, "$datadir/$mnum.poll");
			$poll_question = <FILE>; 
			fclose (FILE);
			chomp $poll_question;
			($dummy, $poll_locked, $dummy) = split(/\|/, $poll_question, 3);
			$micon = qq~$img{'pollicon'}~;
			if ($poll_locked) { $micon = $img{'polliconclosed'}; }
			else {
				fopen(FILE, "$datadir/$mnum.polled");
				$polled = <FILE>;
				fclose(FILE);
				$dlp = &getlog($mnum);
				($dummy, $dummy, $dummy, $vote_date, $dummy) = split(/\|/, $polled);
				$vote_date = stringtotime($vote_date);
				if( $max_log_days_old && $dlp < $vote_date && $username ne 'Guest' && &getlog("$currentboard--mark") < $vote_date ) {$micon = qq~$img{'polliconnew'}~;}
			}
		}

		if( $musername ne 'Guest' && -e "$memberdir/$musername.dat" ) {
			&LoadUser($musername);
			$mname = $userprofile{$musername}->[1] || $mname || $txt{'470'};
			$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$mname</a>~;
		}
		else {
			$mname ||= $txt{'470'};
		}

		# Censor the subject of the thread.
		foreach (@censored) {
			($tmpa,$tmpb) = @{$_};
			$msub =~ s~\Q$tmpa\E~$tmpb~gi;
		}

		# Decide how many pages the thread should have.
		$threadlength = $mreplies + 1;
		$pages = '';
		if( $threadlength > $maxmessagedisplay ) {
			$tmpa = 1;
			for( $tmpb = 0; $tmpb < $threadlength; $tmpb += $maxmessagedisplay ) {
				$pages .= qq~<a href="$cgi;action=display;num=$mnum;start=$tmpb#$tmpb">$tmpa</a>\n~;
				++$tmpa;
			}
			$pages =~ s/\n\Z//;
			$pages = qq~<BR><font size="1">&#171; $txt{'139'} $pages &#187;</font>~;
		}

		if(fopen(FILE, "$datadir/$mnum.data")) {
			$tmpa = <FILE>;
			@other_stuff = <FILE>;
			fclose(FILE);
			chomp $tmpa;
		}
		elsif( -e "$datadir/$mnum.data" ) {
			&fatal_error("301 $txt{'106'}: $txt{'23'} $mnum.data");
		}
		else {
			$tmpa = '0';
		}


		($views, $lastposter) = split(/\|/, $tmpa);
		if( $lastposter =~ m~\AGuest-(.*)~ ) {
			$lastposter = $1;
		}
		else {
			unless( $lastposter eq $txt{'470'} ) {
				$lastposterid = $lastposter;
				&LoadUser($lastposterid);
				if($userprofile{$lastposter}->[1]) { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposterid">$userprofile{$lastposter}->[1]</a>~; }
			}
			&LoadUser($lastposterid);
		}
		$lastpostername = $lastposter || $txt{'470'};
		$views = $views ? $views - 1 : 0;

###Start Sticky Group mod
if(($stkynum && ($counter >= $stkynum)) && ($stkyshowed < 1)){
	$yymain .= qq~
      <tr>
        <td colspan="8" align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%"><font size="1"><b>&nbsp;$stickygrp{'2'}</b></font></td>
      </tr>
~;
$stkyshowed = 1;
}
###End Sticky Group mod

	if(!-e ("$vardir/$mnum.rate") && $autoapplyrate{$currentboard} == 1) {
		if(!-e ("$vardir/rateslist.txt")) {
			fopen(FILE, ">$vardir/rateslist.txt", 1);
			print FILE "|1|1|1\n";
			fclose(FILE);
		}

		fopen(FILE, "$vardir/rateslist.txt");
		@ratelist = <FILE>;
		$listnum = @ratelist;
		fclose(FILE);

		$namestart = "";
		$namestart .= qq($msub|$date);
		$ratelink = qq~$scripturl?board=$currentboard;action=display;num=$mnum~;

		fopen( FILE, ">$vardir/$mnum.rate", 1);
		print FILE "$boardname\n";
		print FILE "$namestart\n";
		print FILE "\n";
		print FILE "0.00|0\n";
		print FILE "$ratelink\n";
		fclose(FILE);

		fopen(FILE, ">$vardir/rateslist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			print FILE "$currate\n";
		}
		print FILE "$viewnum|$username\n";
		fclose(FILE);
	}
	if($autoapplyrate{$currentboard} == 1 && $viewrateindex{$currentboard} == 1) {
		@rateinfo = ();
		fopen(RATEFILEREAD,"$vardir/$mnum.rate");
		@rateinfo = <RATEFILEREAD>;
		$lines = @rateinfo;
		fclose(RATEFILEREAD);
		chomp @rateinfo;
		$raters = $lines - 5;
		($rating, $clicks) = split(/\|/,$rateinfo[3]);
		if($rating == 0) { $rating = "0.00" }
		$barrate = $rating * 10;
		$ratebar = "";
		$ratebar1 = "";
		$ratebar2 = "";
		$barchart = int($barrate);

		$ratebar2 .= qq~<table width="100%" align="center" border="0" cellpadding="2" cellspacing="0"><tr>~;
		if($rategraph{$currentboard} == 1) {

		if($ratestar{$currentboard} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st00.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st01.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st02.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st03.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st04.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
			else { $ratebar2 .= qq~<td align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st05.gif" border="0" alt="" align="absmiddle"></a></font></td>~; }
		}
		else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {$ratebar = "$ratebar";}
			else {
				$ratebar = qq~<img src="$imagesdir/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle">~;
			}
			if ($barchart > 99) {$ratebar1 = "$ratebar1";}
			else {
				$ratebar1 = qq~<img src="$imagesdir/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle">~;
			}
			$ratebar2 .= qq~<td align="left"><a href="$cgi;action=setoverview;rateid=$mnum">$ratebar$ratebar1</a></font></td>~;
		}

		}
		else {

		if($ratestar{$currentboard} == 1) {
			if($barchart < 10) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st00.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 30) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st01.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 50) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st02.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 70) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st03.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			elsif($barchart < 90) { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st04.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
			else { $ratebar2 .= qq~<td width="23%" align="right"><font size="1">$rating</td><td width="59" align="center"><a href="$cgi;action=setoverview;rateid=$mnum"><img src="$imagesdir/st05.gif" border="0" alt="" align="absmiddle"></a></font></td><td align="left"><font size="1">$ratetxt{'05'} $raters</font></td>~; }
		}
		else {
			$barchart1 = 100 - $barchart;
			if ($barchart < 1) {$ratebar = "$ratebar";}
			else {
				$ratebar = qq~<img src="$imagesdir/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle">~;
			}
			if ($barchart > 99) {$ratebar1 = "$ratebar1";}
			else {
				$ratebar1 = qq~<img src="$imagesdir/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle">~;
			}
			$ratebar2 .= qq~<td width="24%" align="right"><font size="1">$rating</td><td align="left"><a href="$cgi;action=setoverview;rateid=$mnum">$ratebar$ratebar1</a></font></td>~;
		}

		}

		$ratebar2 .= qq~</tr></table>~;
	}

		# Print the thread info.
		$mydate = &timeformat($mdate);
		$yymain .= qq~
~;
if($autoapplyrate{$currentboard} == 1 && $viewrateindex{$currentboard} == 1) {
	$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}">$micon</td>
        <td class="windowbg" valign="middle" width="28%" bgcolor="$color{'windowbg'}"><font size="1"><table width="100%" cellborder="0" cellpadding="0" cellspacing="0"><tr><td>$new <a href="$cgi;action=display;num=$mnum"><font size="1"><b>$msub</b></font></a>$pages </font></td><td align="right">$stickdir</td></tr></table></td>
        <td class="windowbg2" valign="middle" align="center" width="12%" bgcolor="$color{'windowbg2'}"><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="1">$mreplies</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="1">$views</font></td>
        <td class="windowbg2" valign="middle" bgcolor="$color{'windowbg2'}"><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
        <td class="windowbg2" align="center" valign="middle" bgcolor="$color{'windowbg2'}">$ratebar2</td>
      </tr>
	~;
}
else {
	$yymain .= qq~
      <tr>
        <td class="windowbg2" valign="middle" align="center" width="6%" bgcolor="$color{'windowbg2'}"><img src="$imagesdir/$threadclass.gif"></td>
        <td class="windowbg2" valign="middle" align="center" width="4%" bgcolor="$color{'windowbg2'}">$micon</td>
        <td class="windowbg" valign="middle" width="44%" bgcolor="$color{'windowbg'}"><font size="1">$new $mpoll<a href="$cgi;action=display;num=$mnum"><b>$msub</b></a> $pages</font></td>
        <td class="windowbg2" valign="middle" align="center" width="14%" bgcolor="$color{'windowbg2'}"><font size="1">$mname</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="1">$mreplies</font></td>
        <td class="windowbg" valign="middle" width="4%" align="center" bgcolor="$color{'windowbg'}"><font size="1">$views</font></td>
        <td class="windowbg2" valign="middle" width="24%" bgcolor="$color{'windowbg2'}"><font size="1">$mydate<br>$txt{'525'} $lastpostername</font></td>
~;
if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)){
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" width="20%" align="center" nowrap><input type="checkbox" name="lockadmin$mcount" value="$mnum">
        <input type="checkbox" name="stickadmin$mcount" value="$mnum">
        <input type="checkbox" name="moveadmin$mcount" value="$mnum">
        <input type="checkbox" name="deleteadmin$mcount" value="$mnum"></td>
        ~;
}
elsif (($settings[7] eq 'Administrator' && $adminview == 2) || ($settings[7] eq 'Global Moderator' && $gmodview == 2) || (exists $moderators{$username} && $modview == 2)){
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" width="20%" align="center"><input type="checkbox" name="admin$mcount" value="$mnum"></td>
        ~;
}
elsif (($settings[7] eq 'Administrator' && $adminview == 1) || ($settings[7] eq 'Global Moderator' && $gmodview == 1) || (exists $moderators{$username} && $modview == 1)){
	$yymain .= qq~
        <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" width="20%" align="center">
            <a href="$cgi;action=lock;thread=$mnum"><img src="$imagesdir/locked.gif" alt="$txt{'104'}" border="0"></a>&nbsp;
            <a href="$cgi;action=sticky;thread=$mnum"><img src="$imagesdir/sticky.gif" alt="$txt{'781'}" border="0"></a>&nbsp;
            <a href="$cgi;action=movethread;thread=$mnum"><img src="$imagesdir/admin_move.gif" alt="$txt{'132'}" border="0"></a>&nbsp;
            <a href="javascript:DoConfirm('$txt{'162'}','$cgi;action=removethread;thread=$mnum')"><img src="$imagesdir/admin_rem.gif" alt="$txt{'63'}" border="0"></a>
        </td>
        ~;
}
$yymain .= qq~
      </tr>
	~;
}
	$yymain .= qq~
~;
		++$counter;
		$mcount++;
	}

	fopen(FILE, "$vardir/cat.txt");
	@categories = <FILE>;
	fclose(FILE);
	$boardlist="";
	foreach $curcat (@categories) {
		$curcat =~ s/[\n\r]//g;
		fopen(CAT, "$boardsdir/$curcat.cat");
		@catinfo = <CAT>;
		fclose(CAT);
		$catinfo[1] =~ s/[\n\r]//g;
		$curcatname="$catinfo[0]";
		boardcheck: foreach $curboard (@catinfo) {
			$curboard =~ s/[\n\r]//g;
			fopen(BOARD, "$boardsdir/$curboard.dat");
			@boardinfo = <BOARD>;
			fclose(BOARD);
			chomp @boardinfo;
			$curboardname = $boardinfo[0];
			if($curboard ne "$catinfo[0]" && $curboard ne "$catinfo[1]" && $currentboard ne $curboard) {
				$curboard =~ s/[\n\r]//g;

				$boardlist .= "<option value=\"$curboard\">$curboardname";
			}
		}
	}
if ($enable_topicrating == 1) {$colspan=8;} else {$colspan=7;}
if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)){
	$yymain .= qq~
        <tr>
          <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" align="right" colspan="$colspan"><font size="1">$txt{'133'}: <select name="toboard">$boardlist</select>	
	    <input type=submit value="$txt{'462'}">
            &nbsp; <i>$txt{'737'}</i></font>
          </td>
          <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" align="center" nowrap>
              <INPUT TYPE="checkbox" name="lockall" value="" ONCLICK="if (this.checked) checkAll(1); else uncheckAll(1);">
              <INPUT TYPE="checkbox" name="stickall" value="" ONCLICK="if (this.checked) checkAll(2); else uncheckAll(2);">
              <INPUT TYPE="checkbox" name="moveall" value="" ONCLICK="if (this.checked) checkAll(3); else uncheckAll(3);">
              <INPUT TYPE="checkbox" name="deleteall" value="" ONCLICK="if (this.checked) checkAll(4); else uncheckAll(4);">
          </td>  
        </tr>
        ~;
}
elsif (($settings[7] eq 'Administrator' && $adminview == 2) || ($settings[7] eq 'Global Moderator' && $gmodview == 2) || (exists $moderators{$username} && $modview == 2)){
	$yymain .= qq~
        <tr>
          <td class="catbg" bgcolor="$color{'catbg'}" colspan="$colspan" valign="middle" align="right"><font size="1">
            <input type="radio" name="action" value="lock" checked> $txt{'104'} &nbsp; 
	    <input type="radio" name="action" value="stick"> $txt{'781'} &nbsp; 
	    <input type="radio" name="action" value="delete"> $txt{'31'} &nbsp; 
	    <input type="radio" name="action" value="move"> $txt{'133'}: <select name="toboard">$boardlist</select>	
	    <input type=submit value="$txt{'462'}">
            &nbsp; <i>$txt{'737'}</i></font>
          </td>
          <td class="catbg" bgcolor="$color{'catbg'}" valign="middle" align="center"><INPUT TYPE="checkbox" name="checkall" value="" ONCLICK="if (this.checked) checkAll(0); else uncheckAll(0);"></td>  
        </tr>
~;
}

	$yymain .= qq~
    </table>
    </td>
  </tr>
</table>
<table border=0 width="100%" cellspacing="0" cellpadding="0" bgcolor="$color{'bordercolor'}" class="bordercolor">
  <tr>
    <td>
    <table cellpadding="4" cellspacing="1" border="0" width="100%">
      <tr>
        <td align="left" class="catbg" bgcolor="$color{'catbg'}" width="100%">
        <table cellpadding="3" cellspacing="0" width="100%">
          <tr>
            <td><font size="1" color="#ffffff"><b>$txt{'139'}:</b> $pageindex</font></td>
	    <td class="catbg" bgcolor="$color{'catbg'}" align=right nowrap><font size="1">
~;
	if ($username ne 'Guest') {
	if($showmarkread) { $yymain .= qq~<a href="$cgi;action=markasread">$img{'markboardread'}</a>~; }
}
	&jumpto;
	$yymain .= qq~
	    $menusep<a href="$cgi;action=post;title=$txt{'464'}">$img{'newthread'}</a>$menusep<a href="$cgi;action=post;title=$polltxt{'1a'}">$img{'createpoll'}</a>&nbsp;
	    </font></td>
	  </tr>
        </table>
        </td>
      </tr>
    </table>
    </td>
  </tr>
</table><br>
~;
if (($settings[7] eq 'Administrator' && $adminview >= 2) || ($settings[7] eq 'Global Moderator' && $gmodview >= 2) || (exists $moderators{$username} && $modview >= 2)) {

	if (($settings[7] eq 'Administrator' && $adminview == 3) || ($settings[7] eq 'Global Moderator' && $gmodview == 3) || (exists $moderators{$username} && $modview == 3)) { $offset="6"; }
	else { $offset="7"; }
	$yymain .= qq~
</form>

<script language="JavaScript1.2" type="text/javascript">
<!-- Begin
function checkAll(j) {
  for (var i = 0; i < document.multiadmin.elements.length - $offset; i++) {
  	if(document.multiadmin.elements[i].name != "subfield" && document.multiadmin.elements[i].name != "msgfield") {
		if (j == 0 ) {document.multiadmin.elements[i].checked = true;}
		if (j != 0 && (i % 4) == (j - 1))  {document.multiadmin.elements[i].checked = true;}
    	}
  }
}
function uncheckAll(j) {
  for (var i = 0; i < document.multiadmin.elements.length - $offset; i++) {
  	if(document.multiadmin.elements[i].name != "subfield" && document.multiadmin.elements[i].name != "msgfield") {
		if (j == 0 ) {document.multiadmin.elements[i].checked = false;}
		if (j != 0 && (i % 4) == (j - 1))  {document.multiadmin.elements[i].checked = false;}
    	}
  }
}
//-->
</script>
	~;
}
$yymain .= qq~
<table cellpadding=0 cellspacing=0 width="100%">
  <tr>
	<td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/thread.gif"> $txt{'457'}<BR>
	<img src="$imagesdir/hotthread.gif"> $txt{'454'}<BR>
	<img src="$imagesdir/veryhotthread.gif"> $txt{'455'}
	</font></td><td align="left" valign="middle"><font size="1">
	<img src="$imagesdir/locked.gif"> $txt{'456'}<BR>
	<img src="$imagesdir/sticky.gif"> $txt{'779'}<BR>
	<img src="$imagesdir/stickylock.gif"> $txt{'780'}
	</font></td>
	<td align="right" valign="middle"><font size="1">$selecthtml</font></td>
  </tr>
</table>
~;
### Quick Reply Box 1.3 ###

	# MBCO2 Post access check
	if ($start_users{$currentboard} || $start_groups{$currentboard}) {
		my $access = &AccessCheck($currentboard, 1) || "";
		if ($access eq "denied") {$enable_quickpost = 0;}
	}

	if ($username ne "Guest" && $enable_quickpost == 1) {
$yymain .= qq~
<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
<form action="$cgi;action=post2" method="post" ENCTYPE="multipart/form-data" name="postmodify" onsubmit="postmodify.post.disabled=true; postmodify.clear.disabled=true;">
<input type="hidden" name="threadid" value="">
<input type="hidden" name="icon" value="xx">
<table border=0 width="80%" cellspacing="1" cellpadding="4" bgcolor="$color{'bordercolor'}" class="bordercolor" align="center">
  <tr>
    <td align="center" class="titlebg" bgcolor="$color{'titlebg'}"><font size="1" class="text1" color="$color{'titletext'}"><b>$qrb_txt{'1'}</b></font></td>
  </tr>
  <tr>
    <td class="windowbg2" bgcolor="$color{'windowbg2'}">
      <table width="100%" cellpadding="4" cellspacing="0">
        <tr>
          <td valign="top" width="23%"><font size="1"><b>$txt{'70'}:</b></font></td>
          <td><font size="1"><input type="text" name="subject" value="" size="40" style="width:100%"></td>
        </tr>~;
		if ($enable_quicksmilies == 1) {
			if ($smiliestyle eq 1){$smiliewinlink = "$scripturl?action=smilieput";} else { $smiliewinlink = "$scripturl?action=smilieindex";}
			$moresmilieslist = ""; 
			$more_smilie_array = ""; 
			$i=0; 
			if ($showadded eq 1){ # show added smilies on smiley bar
				while($SmilieURL[$i]) { 
					if ($SmilieURL[$i]=~ /\//i) {$tmpurl = $SmilieURL[$i];} else {$tmpurl = qq~$imagesdir/$SmilieURL[$i]~;}
					$moresmilieslist .= qq~      document.write("<img src='$tmpurl' align='bottom' alt="+'"'+"$SmilieDescription[$i]"+'"'+" border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'>$SmilieLinebreak[$i] ");\n~; 
					$tmpcode = $SmilieCode[$i];
					$tmpcode =~ s/\&quot;/"+'"'+"/g;
					&FromHTML($tmpcode);
					$tmpcode =~ s/&#36;/\$/g;
					$tmpcode =~ s/&#64;/\@/g;
					$more_smilie_array .= qq~" $tmpcode", ~; 
					$i++; 
				} 
			}
			if ($showsmdir eq 1){ # show auto smilies on smiley bar
				opendir(DIR, "$smiliesdir"); 
				@contents = readdir(DIR); 
				closedir(DIR); 
				foreach $line (sort {uc($a) cmp uc($b)} @contents){ 
					($name, $extension) = split (/\./, $line); 
					if ($extension =~ /gif/i || $extension =~ /jpg/i || $extension =~ /jpeg/i || $extension =~ /png/i ){ 
						if ($line !~ /banner/i) { 
							$moresmilieslist .= qq~      document.write("<img src='$smiliesurl/$line' align='bottom' alt='$name' border='0' onclick='javascript:MoreSmilies($i)' style='cursor:hand'> ");\n~; 
							$more_smilie_array .= qq~" [smiley=$line]", ~; 
							$i++ 
						} 
					} 
				} 
			}
			$more_smilie_array .= qq~""~; 
			$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="1"><b>$txt{'297'}:</b></font></td>
          <td valign="middle">
          <script language="JavaScript1.2" type="text/javascript">
          <!--
            moresmiliecode = new Array($more_smilie_array) 

            function MoreSmilies(i) { 
              AddTxt=moresmiliecode[i]; 
              AddText(AddTxt); 
            }

            function smiliewin() {
              window.open("$smiliewinlink", 'list', 'width=$winwidth,height=$winheight, scrollbars=yes');
            }
  
            if((navigator.appName == "Netscape" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Microsoft Internet Explorer" && navigator.appVersion.charAt(0) >= 4) || (navigator.appName == "Opera" && navigator.appVersion.charAt(0) >= 4)) {
              document.write("<img style='cursor:hand' onclick='javascript:smiley()' src='$imagesdir/smiley.gif' align='bottom' alt='$txt{'287'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:wink()' src='$imagesdir/wink.gif' align='bottom' alt='$txt{'292'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:cheesy()' src='$imagesdir/cheesy.gif' align='bottom' alt='$txt{'289'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:grin()' src='$imagesdir/grin.gif' align='bottom' alt='$txt{'293'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:angry()' src='$imagesdir/angry.gif' align='bottom' alt='$txt{'288'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:sad()' src='$imagesdir/sad.gif' align='bottom' alt='$txt{'291'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:shocked()' src='$imagesdir/shocked.gif' align='bottom' alt='$txt{'294'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:cool()' src='$imagesdir/cool.gif' align='bottom' alt='$txt{'295'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:huh()' src='$imagesdir/huh.gif' align='bottom' alt='$txt{'296'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:rolleyes()' src='$imagesdir/rolleyes.gif' align='bottom' alt='$txt{'450'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:tongue()' src='$imagesdir/tongue.gif' align='bottom' alt='$txt{'451'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:embarassed()' src='$imagesdir/embarassed.gif' align='bottom' alt='$txt{'526'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:lipsrsealed()' src='$imagesdir/lipsrsealed.gif' align='bottom' alt='$txt{'527'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:undecided()' src='$imagesdir/undecided.gif' align='bottom' alt='$txt{'528'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:kiss()' src='$imagesdir/kiss.gif' align='bottom' alt='$txt{'529'}' border='0'> ");
              document.write("<img style='cursor:hand' onclick='javascript:cry()' src='$imagesdir/cry.gif' align='bottom' alt='$txt{'530'}' border='0'> ");
$moresmilieslist
            }
            else { document.write("<font size='1'>$txt{'215'}</font>"); }
          //-->
          </script>~;
		if ($showadded == 3 || ($showadded == 2 && $detachblock == 1) || $showsmdir == 3 || ($showsmdir == 2 && $detachblock == 1)){
			$yymain .= qq~
          <a href=javascript:smiliewin()>$smiltxt{'1'}</a>~;
		}
		$yymain .= qq~ 
          <noscript>
            <font size="1">$txt{'215'}</font>
          </noscript>
          </td>
        </tr>~;
		}
	$yymain .= qq~
        <tr>
          <td valign="top" width="23%"><font size="1"><b>$txt{'72'}:</b></font></td>
          <td><textarea name="message" rows="5" cols="60" wrap="soft" ONCLICK="javascript:storeCaret(this);" ONKEYUP="javascript:storeCaret(this);" ONCHANGE="javascript:storeCaret(this);" style="width:100%"></textarea></td>
        </tr>~;
	if ($allowattach == 1 && (($allowguestattach == 0 && $username ne 'Guest') || $allowguestattach == 1)) {
	$yymain .= qq~
	<tr>
	<td valign="top"><font size="1"><b>$fatxt{'6'}</b></font></td>
	<td><input type="file" name="file" size="49"></td>
	</tr>
	<tr>
	<td align="right"></td>
	<td><font size="1">$filetype_info<br>$filesize_info</font></td>
	</tr>~;
	}
	$yymain .= qq~
      </table>
    </td>
  </tr>
  <tr>
    <td align="center" class="catbg" bgcolor="$color{'catbg'}"><input type="submit" name="post" value="$txt{'105'}" accesskey="s"> &nbsp; <input type="reset" name="clear" value="$txt{'278'}" accesskey="r"></td>
  </tr>
</table>
</form>
~;
	}

### Quick Reply Box 1.3 ###

	$yytitle = $boardname;
	if ($boardlinks == 1) {	$blink =~ s~\~\@~ig; $yymain .= "$blink"; }
	&template;
	exit;
}

sub MarkRead {
	# Mark all threads in this board as read.
	&dumplog("$currentboard--mark");
	$yySetLocation = qq~$scripturl~;
	&redirectexit;
}

1;